summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorAllan McRae <allan@archlinux.org>2009-01-01 19:07:13 +0100
committerDan McGee <dan@archlinux.org>2009-01-03 05:46:47 +0100
commit2f59996c54da473294de4adf44d521299a045a84 (patch)
tree5d7789f02e885afda7213085f8d9c2e918f3643f
parentf4651c49af94164f2c129ea6eb3d78b86be4d5bc (diff)
downloadpacman-2f59996c54da473294de4adf44d521299a045a84.tar.gz
pacman-2f59996c54da473294de4adf44d521299a045a84.tar.xz
makepkg: detect incorrect usage of provides array
Using > or < in the provides array is wrong so make it cause an error. Fixes FS#12540. Also, use bash substitution rather than spawning new processes where possible in the error checking. Move split package detection to a better position. Signed-off-by: Allan McRae <allan@archlinux.org> [Dan: backport to maint] Signed-off-by: Dan McGee <dan@archlinux.org>
-rw-r--r--doc/PKGBUILD.5.txt4
-rw-r--r--scripts/makepkg.sh.in12
2 files changed, 13 insertions, 3 deletions
diff --git a/doc/PKGBUILD.5.txt b/doc/PKGBUILD.5.txt
index 22c56be3..b0f2bdb6 100644
--- a/doc/PKGBUILD.5.txt
+++ b/doc/PKGBUILD.5.txt
@@ -160,7 +160,9 @@ name. The syntax is: `$$source=('filename::url')$$`
depend on 'cron' rather than 'dcron OR fcron'.
Versioned provisions are also possible, in the 'name=version' format.
For example, dcron can provide 'cron=2.0' to satisfy the 'cron>=2.0'
- dependency of other packages.
+ dependency of other packages. Provisions involving the '>' and '<'
+ operators are invalid as only specifc versions of a package may be
+ provided.
*replaces (array)*::
An array of packages that this package should replace, and can be used
diff --git a/scripts/makepkg.sh.in b/scripts/makepkg.sh.in
index b18665c5..04d2aca1 100644
--- a/scripts/makepkg.sh.in
+++ b/scripts/makepkg.sh.in
@@ -1439,11 +1439,11 @@ if [ -z "$pkgrel" ]; then
error "$(gettext "%s is not allowed to be empty.")" "pkgrel"
exit 1
fi
-if [ $(echo "$pkgver" | grep '-') ]; then
+if [ "$pkgver" != "${pkgver//-/}" ]; then
error "$(gettext "%s is not allowed to contain hyphens.")" "pkgver"
exit 1
fi
-if [ $(echo "$pkgrel" | grep '-') ]; then
+if [ "$pkgrel" != "${pkgrel//-/}" ]; then
error "$(gettext "%s is not allowed to contain hyphens.")" "pkgrel"
exit 1
fi
@@ -1465,6 +1465,14 @@ if ! in_array $CARCH ${arch[@]}; then
fi
fi
+for provide in ${provides[@]}; do
+ if [ $provide != ${provide//</} -o $provide != ${provide//>/} ]; then
+ error "$(gettext "Provides array cannot contain comparison (< or >) operators.")"
+ exit 1
+ fi
+done
+unset provide
+
if [ "$install" -a ! -f "$install" ]; then
error "$(gettext "Install scriptlet (%s) does not exist.")" "$install"
exit 1